diff --git a/gcc/ree.c b/gcc/ree.c
index c0d43c8..6ae278b 100644
--- a/gcc/ree.c
+++ b/gcc/ree.c
@@ -940,23 +940,32 @@ gate_handle_ree (void)
   return (optimize > 0 && flag_ree);
 }
 
-struct rtl_opt_pass pass_ree =
+class pass_ree : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "ree",                                /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_handle_ree,                      /* gate */
-  rest_of_handle_ree,                   /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_REE,                               /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish
-    | TODO_verify_rtl_sharing,          /* todo_flags_finish */
- }
-};
+public:
+  pass_ree(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "ree",
+		   OPTGROUP_NONE,
+		   TV_REE,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_handle_ree (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_handle_ree (); }
+
+}; // class pass_ree
+
+rtl_opt_pass *
+make_pass_ree (context &ctxt)
+{
+  return new pass_ree (ctxt);
+}
diff --git a/gcc/reg-stack.c b/gcc/reg-stack.c
index 2812787..03aed36 100644
--- a/gcc/reg-stack.c
+++ b/gcc/reg-stack.c
@@ -3296,25 +3296,35 @@ gate_handle_stack_regs (void)
 #endif
 }
 
-struct rtl_opt_pass pass_stack_regs =
+class pass_stack_regs : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "*stack_regs",                        /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_handle_stack_regs,               /* gate */
-  NULL,					/* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_REG_STACK,                         /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  0                                     /* todo_flags_finish */
- }
-};
+public:
+  pass_stack_regs(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "*stack_regs",
+		   OPTGROUP_NONE,
+		   TV_REG_STACK,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_handle_stack_regs (); }
+
+  bool has_execute () { return false; }
+  unsigned int impl_execute () { return 0; }
+
+}; // class pass_stack_regs
+
+rtl_opt_pass *
+make_pass_stack_regs (context &ctxt)
+{
+  return new pass_stack_regs (ctxt);
+}
 
 /* Convert register usage from flat register file usage to a stack
    register file.  */
@@ -3328,22 +3338,32 @@ rest_of_handle_stack_regs (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_stack_regs_run =
+class pass_stack_regs_run : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "stack",                              /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,                                 /* gate */
-  rest_of_handle_stack_regs,            /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_REG_STACK,                         /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish | TODO_verify_rtl_sharing /* todo_flags_finish */
- }
-};
+public:
+  pass_stack_regs_run(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "stack",
+		   OPTGROUP_NONE,
+		   TV_REG_STACK,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_handle_stack_regs (); }
+
+}; // class pass_stack_regs_run
+
+rtl_opt_pass *
+make_pass_stack_regs_run (context &ctxt)
+{
+  return new pass_stack_regs_run (ctxt);
+}
diff --git a/gcc/regcprop.c b/gcc/regcprop.c
index 97a023f..6948ada 100644
--- a/gcc/regcprop.c
+++ b/gcc/regcprop.c
@@ -1229,23 +1229,32 @@ gate_handle_cprop (void)
 }
 
 
-struct rtl_opt_pass pass_cprop_hardreg =
+class pass_cprop_hardreg : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "cprop_hardreg",                      /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_handle_cprop,                    /* gate */
-  copyprop_hardreg_forward,             /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_CPROP_REGISTERS,                   /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish
-  | TODO_verify_rtl_sharing		/* todo_flags_finish */
- }
-};
+public:
+  pass_cprop_hardreg(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "cprop_hardreg",
+		   OPTGROUP_NONE,
+		   TV_CPROP_REGISTERS,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_handle_cprop (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return copyprop_hardreg_forward (); }
+
+}; // class pass_cprop_hardreg
+
+rtl_opt_pass *
+make_pass_cprop_hardreg (context &ctxt)
+{
+  return new pass_cprop_hardreg (ctxt);
+}
diff --git a/gcc/reginfo.c b/gcc/reginfo.c
index 0153cd9..f75c3e3 100644
--- a/gcc/reginfo.c
+++ b/gcc/reginfo.c
@@ -965,25 +965,35 @@ reginfo_init (void)
   return 1;
 }
 
-struct rtl_opt_pass pass_reginfo_init =
+class pass_reginfo_init : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "reginfo",                            /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,                                 /* gate */
-  reginfo_init,                         /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_NONE,                              /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  0                                     /* todo_flags_finish */
- }
-};
+public:
+  pass_reginfo_init(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "reginfo",
+		   OPTGROUP_NONE,
+		   TV_NONE,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return reginfo_init (); }
+
+}; // class pass_reginfo_init
+
+rtl_opt_pass *
+make_pass_reginfo_init (context &ctxt)
+{
+  return new pass_reginfo_init (ctxt);
+}
 
 
 
diff --git a/gcc/regmove.c b/gcc/regmove.c
index 1ce8a7e..e8527c4 100644
--- a/gcc/regmove.c
+++ b/gcc/regmove.c
@@ -1361,22 +1361,32 @@ gate_handle_regmove (void)
 }
 
 
-struct rtl_opt_pass pass_regmove =
+class pass_regmove : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "regmove",                            /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_handle_regmove,                  /* gate */
-  regmove_optimize,			/* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_REGMOVE,                           /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish | TODO_verify_rtl_sharing /* todo_flags_finish */
- }
-};
+public:
+  pass_regmove(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "regmove",
+		   OPTGROUP_NONE,
+		   TV_REGMOVE,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_handle_regmove (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return regmove_optimize (); }
+
+}; // class pass_regmove
+
+rtl_opt_pass *
+make_pass_regmove (context &ctxt)
+{
+  return new pass_regmove (ctxt);
+}
diff --git a/gcc/regrename.c b/gcc/regrename.c
index 20e2ae9..97048f8 100644
--- a/gcc/regrename.c
+++ b/gcc/regrename.c
@@ -1842,23 +1842,32 @@ gate_handle_regrename (void)
   return (optimize > 0 && (flag_rename_registers));
 }
 
-struct rtl_opt_pass pass_regrename =
+class pass_regrename : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "rnreg",                              /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_handle_regrename,                /* gate */
-  regrename_optimize,                   /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_RENAME_REGISTERS,                  /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish | TODO_verify_rtl_sharing |
-  0                                     /* todo_flags_finish */
- }
-};
+public:
+  pass_regrename(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "rnreg",
+		   OPTGROUP_NONE,
+		   TV_RENAME_REGISTERS,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_rtl_sharing | 0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_handle_regrename (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return regrename_optimize (); }
+
+}; // class pass_regrename
+
+rtl_opt_pass *
+make_pass_regrename (context &ctxt)
+{
+  return new pass_regrename (ctxt);
+}
diff --git a/gcc/reorg.c b/gcc/reorg.c
index 1bc73b0..ca53fb9 100644
--- a/gcc/reorg.c
+++ b/gcc/reorg.c
@@ -3814,25 +3814,35 @@ rest_of_handle_delay_slots (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_delay_slots =
+class pass_delay_slots : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "dbr",                                /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_handle_delay_slots,              /* gate */
-  rest_of_handle_delay_slots,           /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_DBR_SCHED,                         /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  0                                     /* todo_flags_finish */
- }
-};
+public:
+  pass_delay_slots(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "dbr",
+		   OPTGROUP_NONE,
+		   TV_DBR_SCHED,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_handle_delay_slots (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_handle_delay_slots (); }
+
+}; // class pass_delay_slots
+
+rtl_opt_pass *
+make_pass_delay_slots (context &ctxt)
+{
+  return new pass_delay_slots (ctxt);
+}
 
 /* Machine dependent reorg pass.  */
 static bool
@@ -3849,22 +3859,32 @@ rest_of_handle_machine_reorg (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_machine_reorg =
+class pass_machine_reorg : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "mach",                               /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_handle_machine_reorg,            /* gate */
-  rest_of_handle_machine_reorg,         /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_MACH_DEP,                          /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  0                                     /* todo_flags_finish */
- }
-};
+public:
+  pass_machine_reorg(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "mach",
+		   OPTGROUP_NONE,
+		   TV_MACH_DEP,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_handle_machine_reorg (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_handle_machine_reorg (); }
+
+}; // class pass_machine_reorg
+
+rtl_opt_pass *
+make_pass_machine_reorg (context &ctxt)
+{
+  return new pass_machine_reorg (ctxt);
+}
diff --git a/gcc/sched-rgn.c b/gcc/sched-rgn.c
index 6eb00e9..f0dd2fc 100644
--- a/gcc/sched-rgn.c
+++ b/gcc/sched-rgn.c
@@ -3613,44 +3613,62 @@ rest_of_handle_sched2 (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_sched =
-{
- {
-  RTL_PASS,
-  "sched1",                             /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_handle_sched,                    /* gate */
-  rest_of_handle_sched,                 /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_SCHED,                             /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish | TODO_verify_rtl_sharing |
-  TODO_verify_flow                      /* todo_flags_finish */
- }
-};
+class pass_sched : public rtl_opt_pass
+{
+public:
+  pass_sched(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "sched1",
+		   OPTGROUP_NONE,
+		   TV_SCHED,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_rtl_sharing | TODO_verify_flow)))
+  {}
 
-struct rtl_opt_pass pass_sched2 =
-{
- {
-  RTL_PASS,
-  "sched2",                             /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_handle_sched2,                   /* gate */
-  rest_of_handle_sched2,                /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_SCHED2,                            /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish | TODO_verify_rtl_sharing |
-  TODO_verify_flow                      /* todo_flags_finish */
- }
-};
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_handle_sched (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_handle_sched (); }
+
+}; // class pass_sched
+
+rtl_opt_pass *
+make_pass_sched (context &ctxt)
+{
+  return new pass_sched (ctxt);
+}
+
+class pass_sched2 : public rtl_opt_pass
+{
+public:
+  pass_sched2(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "sched2",
+		   OPTGROUP_NONE,
+		   TV_SCHED2,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_rtl_sharing | TODO_verify_flow)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_handle_sched2 (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_handle_sched2 (); }
+
+}; // class pass_sched2
+
+rtl_opt_pass *
+make_pass_sched2 (context &ctxt)
+{
+  return new pass_sched2 (ctxt);
+}
diff --git a/gcc/stack-ptr-mod.c b/gcc/stack-ptr-mod.c
index 739bcfc..16f6559 100644
--- a/gcc/stack-ptr-mod.c
+++ b/gcc/stack-ptr-mod.c
@@ -90,22 +90,32 @@ rest_of_handle_stack_ptr_mod (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_stack_ptr_mod =
+class pass_stack_ptr_mod : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "*stack_ptr_mod",                     /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,                                 /* gate */
-  rest_of_handle_stack_ptr_mod,         /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_NONE,                              /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  0                                     /* todo_flags_finish */
- }
-};
+public:
+  pass_stack_ptr_mod(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "*stack_ptr_mod",
+		   OPTGROUP_NONE,
+		   TV_NONE,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_handle_stack_ptr_mod (); }
+
+}; // class pass_stack_ptr_mod
+
+rtl_opt_pass *
+make_pass_stack_ptr_mod (context &ctxt)
+{
+  return new pass_stack_ptr_mod (ctxt);
+}
diff --git a/gcc/store-motion.c b/gcc/store-motion.c
index 6fc072c..4b23e44 100644
--- a/gcc/store-motion.c
+++ b/gcc/store-motion.c
@@ -1232,23 +1232,32 @@ execute_rtl_store_motion (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_rtl_store_motion =
+class pass_rtl_store_motion : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "store_motion",                       /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_rtl_store_motion,                /* gate */
-  execute_rtl_store_motion,		/* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_LSM,                               /* tv_id */
-  PROP_cfglayout,                       /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish | TODO_verify_rtl_sharing |
-  TODO_verify_flow                      /* todo_flags_finish */
- }
-};
+public:
+  pass_rtl_store_motion(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "store_motion",
+		   OPTGROUP_NONE,
+		   TV_LSM,
+		   pass_properties(required(PROP_cfglayout),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_rtl_sharing | TODO_verify_flow)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_rtl_store_motion (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_rtl_store_motion (); }
+
+}; // class pass_rtl_store_motion
+
+rtl_opt_pass *
+make_pass_rtl_store_motion (context &ctxt)
+{
+  return new pass_rtl_store_motion (ctxt);
+}
diff --git a/gcc/testsuite/g++.dg/plugin/dumb_plugin.c b/gcc/testsuite/g++.dg/plugin/dumb_plugin.c
index 0f15140..b1610de 100644
--- a/gcc/testsuite/g++.dg/plugin/dumb_plugin.c
+++ b/gcc/testsuite/g++.dg/plugin/dumb_plugin.c
@@ -57,25 +57,35 @@ gate_dumb_plugin_example (void)
   return true;
 }
 
-static struct gimple_opt_pass pass_dumb_plugin_example =
+class pass_dumb_plugin_example : public gimple_opt_pass
 {
-  {
-    GIMPLE_PASS,
-    "dumb_plugin_example",                /* name */
-    OPTGROUP_NONE,                        /* optinfo_flags */
-    gate_dumb_plugin_example,             /* gate */
-    execute_dumb_plugin_example,          /* execute */
-    NULL,                                 /* sub */
-    NULL,                                 /* next */
-    0,                                    /* static_pass_number */
-    TV_NONE,                              /* tv_id */
-    PROP_cfg,                             /* properties_required */
-    0,                                    /* properties_provided */
-    0,                                    /* properties_destroyed */
-    0,                                    /* todo_flags_start */
-    0					  /* todo_flags_finish */
-  }
-};
+public:
+  pass_dumb_plugin_example(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "dumb_plugin_example",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_cfg),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_dumb_plugin_example (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_dumb_plugin_example (); }
+
+}; // class pass_dumb_plugin_example
+
+static gimple_opt_pass *
+make_pass_dumb_plugin_example (context &ctxt)
+{
+  return new pass_dumb_plugin_example (ctxt);
+}
 
 /* Initialization function that GCC calls. This plugin takes an argument
    that specifies the name of the reference pass and an instance number,
diff --git a/gcc/testsuite/g++.dg/plugin/selfassign.c b/gcc/testsuite/g++.dg/plugin/selfassign.c
index 37a0a97..1b5298a 100644
--- a/gcc/testsuite/g++.dg/plugin/selfassign.c
+++ b/gcc/testsuite/g++.dg/plugin/selfassign.c
@@ -263,25 +263,35 @@ gate_warn_self_assign (void)
   return true;
 }
 
-static struct gimple_opt_pass pass_warn_self_assign =
+class pass_warn_self_assign : public gimple_opt_pass
 {
-  {
-    GIMPLE_PASS,
-    "warn_self_assign",                   /* name */
-    OPTGROUP_NONE,                        /* optinfo_flags */
-    gate_warn_self_assign,                /* gate */
-    execute_warn_self_assign,             /* execute */
-    NULL,                                 /* sub */
-    NULL,                                 /* next */
-    0,                                    /* static_pass_number */
-    TV_NONE,                              /* tv_id */
-    PROP_ssa,                             /* properties_required */
-    0,                                    /* properties_provided */
-    0,                                    /* properties_destroyed */
-    0,                                    /* todo_flags_start */
-    0					  /* todo_flags_finish */
-  }
-};
+public:
+  pass_warn_self_assign(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "warn_self_assign",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_warn_self_assign (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_warn_self_assign (); }
+
+}; // class pass_warn_self_assign
+
+static gimple_opt_pass *
+make_pass_warn_self_assign (context &ctxt)
+{
+  return new pass_warn_self_assign (ctxt);
+}
 
 /* The initialization routine exposed to and called by GCC. The spec of this
    function is defined in gcc/gcc-plugin.h.
diff --git a/gcc/testsuite/gcc.dg/plugin/one_time_plugin.c b/gcc/testsuite/gcc.dg/plugin/one_time_plugin.c
index 45e6257..4ef813d 100644
--- a/gcc/testsuite/gcc.dg/plugin/one_time_plugin.c
+++ b/gcc/testsuite/gcc.dg/plugin/one_time_plugin.c
@@ -27,25 +27,35 @@ static unsigned int one_pass_exec (void)
  return 0;
 }
 
-struct gimple_opt_pass one_pass = 
+class one_pass : public gimple_opt_pass
 {
-  {
-  GIMPLE_PASS,
-  "cfg",                           /* name */
-  OPTGROUP_NONE,                         /* optinfo_flags */
-  one_pass_gate,                         /* gate */
-  one_pass_exec,       /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_NONE,                              /* tv_id */
-  PROP_gimple_any,                      /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  0					/* todo_flags_finish */
-  }
-};
+public:
+  one_pass(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "cfg",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_gimple_any),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return one_pass_gate (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return one_pass_exec (); }
+
+}; // class one_pass
+
+gimple_opt_pass *
+make_one_pass (context &ctxt)
+{
+  return new one_pass (ctxt);
+}
 
 
 int plugin_init (struct plugin_name_args *plugin_info,
diff --git a/gcc/testsuite/gcc.dg/plugin/selfassign.c b/gcc/testsuite/gcc.dg/plugin/selfassign.c
index 37a0a97..1b5298a 100644
--- a/gcc/testsuite/gcc.dg/plugin/selfassign.c
+++ b/gcc/testsuite/gcc.dg/plugin/selfassign.c
@@ -263,25 +263,35 @@ gate_warn_self_assign (void)
   return true;
 }
 
-static struct gimple_opt_pass pass_warn_self_assign =
+class pass_warn_self_assign : public gimple_opt_pass
 {
-  {
-    GIMPLE_PASS,
-    "warn_self_assign",                   /* name */
-    OPTGROUP_NONE,                        /* optinfo_flags */
-    gate_warn_self_assign,                /* gate */
-    execute_warn_self_assign,             /* execute */
-    NULL,                                 /* sub */
-    NULL,                                 /* next */
-    0,                                    /* static_pass_number */
-    TV_NONE,                              /* tv_id */
-    PROP_ssa,                             /* properties_required */
-    0,                                    /* properties_provided */
-    0,                                    /* properties_destroyed */
-    0,                                    /* todo_flags_start */
-    0					  /* todo_flags_finish */
-  }
-};
+public:
+  pass_warn_self_assign(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "warn_self_assign",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_warn_self_assign (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_warn_self_assign (); }
+
+}; // class pass_warn_self_assign
+
+static gimple_opt_pass *
+make_pass_warn_self_assign (context &ctxt)
+{
+  return new pass_warn_self_assign (ctxt);
+}
 
 /* The initialization routine exposed to and called by GCC. The spec of this
    function is defined in gcc/gcc-plugin.h.
